VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The grab handle we are dragging. This is 0
' when we are not dragging any handle.
Private m_DraggingHandle As Integer

' The data points.
Private m_NumPoints As Single
Private m_PointX() As Single
Private m_PointY() As Single

Private Const HANDLE_WIDTH = 80
Private Const HANDLE_HALF_WIDTH = HANDLE_WIDTH / 2

' Create some initial point data.
Private Sub Form_Load()
    ' Make room.
    m_NumPoints = 5
    ReDim m_PointX(1 To m_NumPoints)
    ReDim m_PointY(1 To m_NumPoints)

    ' Set initial points.
    m_PointX(1) = 1335: m_PointY(1) = 1890
    m_PointX(2) = 1245: m_PointY(2) = 1110
    m_PointX(3) = 2460: m_PointY(3) = 915
    m_PointX(4) = 3810: m_PointY(4) = 1830
    m_PointX(5) = 2610: m_PointY(5) = 2145

    ' Draw.
    Refresh
End Sub
' See if we are over a grab handle.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer
Dim dx As Single
Dim dy As Single

    For i = 1 To m_NumPoints
        If Abs(m_PointX(i) - X) < HANDLE_HALF_WIDTH And _
           Abs(m_PointY(i) - Y) < HANDLE_HALF_WIDTH _
        Then
            ' We are over this grab handle.
            ' Start dragging.
            m_DraggingHandle = i
            Exit For
        End If
    Next i
End Sub

' Move the drag handle.
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if we are not dragging.
    If m_DraggingHandle = 0 Then Exit Sub

    ' Move the handle.
    m_PointX(m_DraggingHandle) = X
    m_PointY(m_DraggingHandle) = Y

    ' Redraw.
    Refresh
End Sub


' Stop dragging.
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_DraggingHandle = 0
End Sub


Private Sub Form_Paint()
Dim i As Integer

    Cls
    If m_NumPoints < 1 Then Exit Sub

    ' Start at the last point.
    CurrentX = m_PointX(m_NumPoints)
    CurrentY = m_PointY(m_NumPoints)

    ' Connect the points.
    For i = 1 To m_NumPoints
        Line -(m_PointX(i), m_PointY(i))
    Next i

    ' Draw grab handles as white squares with
    ' black edges.
    FillColor = vbWhite
    FillStyle = vbFSSolid
    For i = 1 To m_NumPoints
        Line (m_PointX(i) - HANDLE_HALF_WIDTH, m_PointY(i) - HANDLE_HALF_WIDTH)-Step(HANDLE_WIDTH, HANDLE_WIDTH), , B
    Next i
End Sub
